Index: /trunk/LMDZ.MARS/libf/aeronomars/paramfoto_compact.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/paramfoto_compact.F	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/paramfoto_compact.F	(revision 658)
@@ -1,3 +1,2 @@
-
 c**********************************************************************
 
@@ -1449,5 +1448,5 @@
 	   enddo
 	   incremento = ( tehanson(i2)-tehanson(i1) ) / 
-	1	( zhanson(i2)-zhanson(i1) )
+     $          ( zhanson(i2)-zhanson(i1) )
 	   t_elect = tehanson(i1) + (zkm-zhanson(i1)) * incremento
 	endif
@@ -1814,141 +1813,141 @@
          !Initialization of lifetimes
          do j = 1, nreact
-            tauco2(i,j)  = 1.d30
-            tauo2(i,j)   = 1.d30
-            tauo3p(i,j)  = 1.d30
-            tauco(i,j)   = 1.d30
-            tauh(i,j)    = 1.d30
-            tauoh(i,j)   = 1.d30
-            tauho2(i,j)  = 1.d30
-            tauh2(i,j)   = 1.d30
-            tauh2o(i,j)  = 1.d30
-            tauo1d(i,j)  = 1.d30
-            tauh2o2(i,j) = 1.d30
-            tauo3(i,j)   = 1.d30
-            taun2(i,j)   = 1.d30
-            taun(i,j)    = 1.d30
-            tauno(i,j)   = 1.d30
-            taun2d(i,j)  = 1.d30
-            tauno2(i,j)  = 1.d30
-            tauco2plus(i,j) = 1.d30
-            tauoplus(i,j)   = 1.d30
-	    tauo2plus(i,j)  = 1.d30
-            taucoplus(i,j)  = 1.d30
-	    taucplus(i,j)   = 1.d30
-	    taunplus(i,j)   = 1.d30
-	    taun2plus(i,j)  = 1.d30
-            taunoplus(i,j)  = 1.d30
-	    tauhplus(i,j)   = 1.d30
-            tauhco2plus(i,j)= 1.d30
+            tauco2(j,i)  = 1.d30
+            tauo2(j,i)   = 1.d30
+            tauo3p(j,i)  = 1.d30
+            tauco(j,i)   = 1.d30
+            tauh(j,i)    = 1.d30
+            tauoh(j,i)   = 1.d30
+            tauho2(j,i)  = 1.d30
+            tauh2(j,i)   = 1.d30
+            tauh2o(j,i)  = 1.d30
+            tauo1d(j,i)  = 1.d30
+            tauh2o2(j,i) = 1.d30
+            tauo3(j,i)   = 1.d30
+            taun2(j,i)   = 1.d30
+            taun(j,i)    = 1.d30
+            tauno(j,i)   = 1.d30
+            taun2d(j,i)  = 1.d30
+            tauno2(j,i)  = 1.d30
+            tauco2plus(j,i) = 1.d30
+            tauoplus(j,i)   = 1.d30
+	    tauo2plus(j,i)  = 1.d30
+            taucoplus(j,i)  = 1.d30
+	    taucplus(j,i)   = 1.d30
+	    taunplus(j,i)   = 1.d30
+	    taun2plus(j,i)  = 1.d30
+            taunoplus(j,i)  = 1.d30
+	    tauhplus(j,i)   = 1.d30
+            tauhco2plus(j,i)= 1.d30
          end do
 
          !Lifetime of each species in each reaction
-         if(jdistot8(1,i).gt.1.d-30) tauco2(i,1) = 1.d0 / jdistot8(1,i)
+         if(jdistot8(1,i).gt.1.d-30) tauco2(1,i) = 1.d0 / jdistot8(1,i)
 		 
          if(ch2*o2xini*co2xini.gt.1.d-30) 
-     $      tauh(i,2) = 1.d0 / (ch2 * o2xini * co2xini)  
+     $      tauh(2,i) = 1.d0 / (ch2 * o2xini * co2xini)  
          if(ch2*hxini*co2xini.gt.1.d-30)
-     $      tauo2(i,2) = 1.d0 / (ch2 * hxini * co2xini)
+     $      tauo2(2,i) = 1.d0 / (ch2 * hxini * co2xini)
  
-         if(ch3*o3pxini.gt.1.d-30) tauho2(i,3) = 1.d0 / 
+         if(ch3*o3pxini.gt.1.d-30) tauho2(3,i) = 1.d0 / 
      $        (ch3 * o3pxini)
-         if(ch3*ho2xini.gt.1.d-30) tauo3p(i,3) = 1.d0 / 
+         if(ch3*ho2xini.gt.1.d-30) tauo3p(3,i) = 1.d0 / 
      $        (ch3 * ho2xini)
  
-         if(ch4*coxini.gt.1.d-30) tauoh(i,4) = 1.d0 / 
+         if(ch4*coxini.gt.1.d-30) tauoh(4,i) = 1.d0 / 
      $        (ch4 * coxini)
-         if(ch4*ohxini.gt.1.d-30) tauco(i,4) = 1.d0 / 
+         if(ch4*ohxini.gt.1.d-30) tauco(4,i) = 1.d0 / 
      $        (ch4 * ohxini)
  
-         if(ch5*ho2xini.gt.1.d-30)tauho2(i,5)=1.d0 / 
+         if(ch5*ho2xini.gt.1.d-30)tauho2(5,i)=1.d0 / 
      $        (2.d0*ch5*ho2xini)
 
 		 
-	 if(jdistot8(6,i).gt.1.d-30) tauh2o2(i,6) = 1.d0 / jdistot8(6,i)
-
-         if(ch7*ohxini.gt.1.d-30) tauho2(i,7) = 1.d0 / 
+	 if(jdistot8(6,i).gt.1.d-30) tauh2o2(6,i) = 1.d0 / jdistot8(6,i)
+
+         if(ch7*ohxini.gt.1.d-30) tauho2(7,i) = 1.d0 / 
      $        (ch7 * ohxini)
-         if(ch7*ho2xini.gt.1.d-30) tauoh(i,7) = 1.d0 / 
+         if(ch7*ho2xini.gt.1.d-30) tauoh(7,i) = 1.d0 / 
      $        (ch7 * ho2xini)
  
-         if(jdistot8(4,i).gt.1.d-30) tauh2o(i,8) = 1.d0 / jdistot8(4,i)
-
-	 if(ch9*o1dxini.gt.1.d-30) tauh2o(i,9) = 1.d0 / 
+         if(jdistot8(4,i).gt.1.d-30) tauh2o(8,i) = 1.d0 / jdistot8(4,i)
+
+	 if(ch9*o1dxini.gt.1.d-30) tauh2o(9,i) = 1.d0 / 
      $        (ch9 * o1dxini)
-         if(ch9*h2oxini.gt.1.d-30) tauo1d(i,9) = 1.d0 / 
+         if(ch9*h2oxini.gt.1.d-30) tauo1d(9,i) = 1.d0 / 
      $        (ch9 * h2oxini)
 
          if(ch10*o3pxini*co2xini.gt.1.d-30) 
-     $     tauo3p(i,10) = 1.d0 / 
+     $     tauo3p(10,i) = 1.d0 / 
      $        (2.d0 * ch10 * o3pxini * co2xini)
 
-         if(ch11*o3pxini.gt.1.d-30) tauoh(i,11)=1.d0 / 
+         if(ch11*o3pxini.gt.1.d-30) tauoh(11,i)=1.d0 / 
      $        (ch11 * o3pxini)
-         if(ch11*ohxini.gt.1.d-30) tauo3p(i,11) = 1.d0 / 
+         if(ch11*ohxini.gt.1.d-30) tauo3p(11,i) = 1.d0 / 
      $        (ch11 * ohxini)
 
-         if(jdistot8(2,i).gt.1.d-30) tauo2(i,12) = 1.d0 / jdistot8(2,i)
-
-         if(ch13*hxini.gt.1.d-30) tauho2(i,13) = 1.d0 / 
+         if(jdistot8(2,i).gt.1.d-30) tauo2(12,i) = 1.d0 / jdistot8(2,i)
+
+         if(ch13*hxini.gt.1.d-30) tauho2(13,i) = 1.d0 / 
      $        (ch13 * hxini)
-         if(ch13*ho2xini.gt.1.d-30) tauh(i,13) = 1.d0 / 
+         if(ch13*ho2xini.gt.1.d-30) tauh(13,i) = 1.d0 / 
      $        (ch13 * ho2xini)
 
-         if(ch14*o1dxini.gt.1.d-30) tauh2(i,14) = 1.d0 / 
+         if(ch14*o1dxini.gt.1.d-30) tauh2(14,i) = 1.d0 / 
      $        (ch14 * o1dxini)
-         if(ch14*h2xini.gt.1.d-30) tauo1d(i,14) = 1.d0 / 
+         if(ch14*h2xini.gt.1.d-30) tauo1d(14,i) = 1.d0 / 
      $        (ch14 * h2xini)
 
-         if(ch15*ohxini.gt.1.d-30) tauh2(i,15) = 1.d0 / 
+         if(ch15*ohxini.gt.1.d-30) tauh2(15,i) = 1.d0 / 
      $        (ch15 * ohxini)
-         if(ch15*h2xini.gt.1.d-30) tauoh(i,15) = 1.d0 / 
+         if(ch15*h2xini.gt.1.d-30) tauoh(15,i) = 1.d0 / 
      $        (ch15 * h2xini)
 
-         if(jdistot8_b(1,i).gt.1.d-30) tauco2(i,16)=1.d0/jdistot8_b(1,i)
-
-         if(jdistot8_b(2,i).gt.1.d-30) tauo2(i,17)=1.d0/jdistot8_b(2,i)
-
-         if(ch18*ohxini.gt.1.d-30) tauh2o2(i,18)=1.d0 / 
+         if(jdistot8_b(1,i).gt.1.d-30) tauco2(16,i)=1.d0/jdistot8_b(1,i)
+
+         if(jdistot8_b(2,i).gt.1.d-30) tauo2(17,i)=1.d0/jdistot8_b(2,i)
+
+         if(ch18*ohxini.gt.1.d-30) tauh2o2(18,i)=1.d0 / 
      $        (ch18 * ohxini)
-         if(ch18*h2o2xini.gt.1.d-30) tauoh(i,18)=1.d0 / 
+         if(ch18*h2o2xini.gt.1.d-30) tauoh(18,i)=1.d0 / 
      $        (ch18 * h2o2xini)
 
-         if(ch19*co2xini.gt.1.d-30)tauo1d(i,19)=1.d0 / 
+         if(ch19*co2xini.gt.1.d-30)tauo1d(19,i)=1.d0 / 
      $        (ch19 * co2xini)
 
-         if(ch20*o2xini.gt.1.d-30)tauo1d(i,20)= 1.d0 / 
+         if(ch20*o2xini.gt.1.d-30)tauo1d(20,i)= 1.d0 / 
      $        (ch20 * o2xini)
 
-         if(ch21*o2xini*co2xini.gt.1.d-30)tauo3p(i,21)= 1.d0 / 
+         if(ch21*o2xini*co2xini.gt.1.d-30)tauo3p(21,i)= 1.d0 / 
      $        (ch21 * o2xini * co2xini)
-         if(ch21*o3pxini*co2xini.gt.1.d-30) tauo2(i,21) = 1.d0 / 
+         if(ch21*o3pxini*co2xini.gt.1.d-30) tauo2(21,i) = 1.d0 / 
      $        (ch21 * o3pxini * co2xini)
 
          !Only if O3, N or ion chemistry requested
          if(chemthermod.ge.1) then
-            if(ch22*hxini.gt.1.d-30) tauo3(i,22) = 1.d0 / 
+            if(ch22*hxini.gt.1.d-30) tauo3(22,i) = 1.d0 / 
      $           (ch22 * hxini)
-            if(ch22*o3xini.gt.1.d-30) tauh(i,22) = 1.d0 / 
+            if(ch22*o3xini.gt.1.d-30) tauh(22,i) = 1.d0 / 
      $           (ch22 * o3xini)
             
-            if(ch23*ohxini.gt.1.d-30) tauo3(i,23) = 1.d0 / 
+            if(ch23*ohxini.gt.1.d-30) tauo3(23,i) = 1.d0 / 
      $           (ch23 * ohxini)
-            if(ch23*o3xini.gt.1.d-30) tauoh(i,23) = 1.d0 / 
+            if(ch23*o3xini.gt.1.d-30) tauoh(23,i) = 1.d0 / 
      $           (ch23 * o3xini)
             
-            if(ch24 * ho2xini.gt.1.d-30)tauo3(i,24)= 1.d0 / 
+            if(ch24 * ho2xini.gt.1.d-30)tauo3(24,i)= 1.d0 / 
      $           (ch24 * ho2xini)
-            if(ch24 * o3xini.gt.1.d-30)tauho2(i,24)= 1.d0 / 
+            if(ch24 * o3xini.gt.1.d-30)tauho2(24,i)= 1.d0 / 
      $           (ch24 * o3xini)
             
-            if(jdistot8(7,i).gt.1.d-30) tauo3(i,25)=1.d0 /
+            if(jdistot8(7,i).gt.1.d-30) tauo3(25,i)=1.d0 /
      $           jdistot8(7,i)
 
-            if(jdistot8_b(7,i).gt.1.d-30) tauo3(i,26)= 1.d0 /
+            if(jdistot8_b(7,i).gt.1.d-30) tauo3(26,i)= 1.d0 /
      $           jdistot8_b(7,i)
 
          endif    !Of chemthermod.ge.1
 
-         if(jdistot8(5,i).gt.1.d-30) tauh2(i,27)= 1.d0/jdistot8(5,i)
+         if(jdistot8(5,i).gt.1.d-30) tauh2(27,i)= 1.d0/jdistot8(5,i)
 
 !         if(ch28 * h2oxini.gt.1.d-30) tauo3(i,28) = 1.d0/(ch28*h2oxini)
@@ -1957,86 +1956,86 @@
          !Only if N or ion chemistry requested
          if(chemthermod.ge.2) then
-            if(jdistot8(8,i).gt.1.d-30) taun2(i,28) = 1.d0 / 
+            if(jdistot8(8,i).gt.1.d-30) taun2(28,i) = 1.d0 / 
      $           jdistot8(8,i)
 
-            if(jdistot8(10,i).gt.1.d-30) tauno(i,29) = 1.d0 /
+            if(jdistot8(10,i).gt.1.d-30) tauno(29,i) = 1.d0 /
      $           jdistot8(10,i)
 
-            if(ch30 * noxini.gt.1.d-30) taun(i,30) = 1.d0 / 
+            if(ch30 * noxini.gt.1.d-30) taun(30,i) = 1.d0 / 
      $           (ch30 * noxini)
-            if(ch30 * nxini.gt.1.d-30) tauno(i,30) = 1.d0 / 
+            if(ch30 * nxini.gt.1.d-30) tauno(30,i) = 1.d0 / 
      $           (ch30 * nxini)
 
-            if(ch31 * o1dxini.gt.1.d-30) taun2(i,31) = 1.d0 / 
+            if(ch31 * o1dxini.gt.1.d-30) taun2(31,i) = 1.d0 / 
      $           (ch31 * o1dxini)
-            if(ch31 * n2xini.gt.1.d-30) tauo1d(i,31) = 1.d0 /
+            if(ch31 * n2xini.gt.1.d-30) tauo1d(31,i) = 1.d0 /
      $           (ch31 * n2xini)
 
-            if(ch32 * o2xini.gt.1.d-30) taun(i,32) = 1.d0 /
+            if(ch32 * o2xini.gt.1.d-30) taun(32,i) = 1.d0 /
      $           (ch32 * o2xini)
-            if(ch32 * nxini.gt.1.d-30) tauo2(i,32) = 1.d0 /
+            if(ch32 * nxini.gt.1.d-30) tauo2(32,i) = 1.d0 /
      $           (ch32 * nxini)
             
-            if(ch33 * ohxini.gt.1.d-30) taun(i,33) = 1.d0 /
+            if(ch33 * ohxini.gt.1.d-30) taun(33,i) = 1.d0 /
      $           (ch33 * ohxini)
-            if(ch33 * nxini.gt.1.d-30) tauoh(i,33) = 1.d0 /
+            if(ch33 * nxini.gt.1.d-30) tauoh(33,i) = 1.d0 /
      $           (ch33 * nxini)
 
-            if(ch34 * o3xini.gt.1.d-30) taun(i,34) = 1.d0 /
+            if(ch34 * o3xini.gt.1.d-30) taun(34,i) = 1.d0 /
      $           (ch34 * o3xini)
-            if(ch34 * nxini.gt.1.d-30) tauo3(i,34) = 1.d0 /
+            if(ch34 * nxini.gt.1.d-30) tauo3(34,i) = 1.d0 /
      $           (ch34 * nxini)
             
-            if(ch35 * ho2xini.gt.1.d-30) taun(i,35) = 1.d0 /
+            if(ch35 * ho2xini.gt.1.d-30) taun(35,i) = 1.d0 /
      $           (ch35 * ho2xini)
-            if(ch35 * nxini.gt.1.d-30) tauho2(i,35) = 1.d0 /
+            if(ch35 * nxini.gt.1.d-30) tauho2(35,i) = 1.d0 /
      $           (ch35 * nxini)
             
-            if(ch36 * o3pxini.gt.1.d-30) taun2d(i,36) = 1.d0 /
+            if(ch36 * o3pxini.gt.1.d-30) taun2d(36,i) = 1.d0 /
      $           (ch36 * o3pxini)
-            if(ch36 * n2dxini.gt.1.d-30) tauo3p(i,36) = 1.d0 /
+            if(ch36 * n2dxini.gt.1.d-30) tauo3p(36,i) = 1.d0 /
      $           (ch36 * n2dxini)
             
-            if(ch37 * n2xini.gt.1.d-30) taun2d(i,37) = 1.d0 /
+            if(ch37 * n2xini.gt.1.d-30) taun2d(37,i) = 1.d0 /
      $           (ch37 * n2xini)
-            if(ch37 * n2dxini.gt.1.d-30) taun2(i,37) = 1.d0 /
+            if(ch37 * n2dxini.gt.1.d-30) taun2(37,i) = 1.d0 /
      $           (ch37 * n2dxini)
             
-            if(ch38 * co2xini.gt.1.d-30) taun2d(i,38) = 1.d0 /
+            if(ch38 * co2xini.gt.1.d-30) taun2d(38,i) = 1.d0 /
      $           (ch38 * co2xini)
-            if(ch38 * n2dxini.gt.1.d-30) tauco2(i,38) = 1.d0 /
+            if(ch38 * n2dxini.gt.1.d-30) tauco2(38,i) = 1.d0 /
      $           (ch38 * n2dxini)
             
-            if(ch39 * ho2xini.gt.1.d-30) tauno(i,39) = 1.d0 /
+            if(ch39 * ho2xini.gt.1.d-30) tauno(39,i) = 1.d0 /
      $           (ch39 * ho2xini)
-            if(ch39 * noxini.gt.1.d-30) tauho2(i,39) = 1.d0 /
+            if(ch39 * noxini.gt.1.d-30) tauho2(39,i) = 1.d0 /
      $           (ch39 * noxini)
             
-            if(ch40 * noxini * co2xini.gt.1.d-30) tauo3p(i,40) = 1.d0 /
+            if(ch40 * noxini * co2xini.gt.1.d-30) tauo3p(40,i) = 1.d0 /
      $           (ch40 * noxini * co2xini)
-            if(ch40 * o3pxini * co2xini.gt.1.d-30) tauno(i,40) = 1.d0 /
+            if(ch40 * o3pxini * co2xini.gt.1.d-30) tauno(40,i) = 1.d0 /
      $           (ch40 * o3pxini * co2xini)
             
-            if(ch41 * no2xini.gt.1.d-30) tauo3p(i,41) = 1.d0 /
+            if(ch41 * no2xini.gt.1.d-30) tauo3p(41,i) = 1.d0 /
      $           (ch41 * no2xini)
-            if(ch41 * o3pxini.gt.1.d-30) tauno2(i,41) = 1.d0 /
+            if(ch41 * o3pxini.gt.1.d-30) tauno2(41,i) = 1.d0 /
      $           (ch41 * o3pxini)
             
-            if(ch42 * noxini.gt.1.d-30) tauo3(i,42) = 1.d0 /
+            if(ch42 * noxini.gt.1.d-30) tauo3(42,i) = 1.d0 /
      $           (ch42 * noxini)
-            if(ch42 * o3xini.gt.1.d-30) tauno(i,42) = 1.d0 /
+            if(ch42 * o3xini.gt.1.d-30) tauno(42,i) = 1.d0 /
      $           (ch42 * o3xini)
             
-            if(ch43 * no2xini.gt.1.d-30) tauh(i,43) = 1.d0 /
+            if(ch43 * no2xini.gt.1.d-30) tauh(43,i) = 1.d0 /
      $           (ch43 * no2xini)
-            if(ch43 * hxini.gt.1.d-30) tauno2(i,43) = 1.d0 /
+            if(ch43 * hxini.gt.1.d-30) tauno2(43,i) = 1.d0 /
      $           (ch43 * hxini)
 
-            if(jdistot8(13,i).gt.1.d-30) tauno2(i,44) = 1.d0 / 
+            if(jdistot8(13,i).gt.1.d-30) tauno2(44,i) = 1.d0 / 
      $           jdistot8(13,i)
 
-            if(ch45 * nxini.gt.1.d-30) tauo3p(i,45) = 1.d0 / 
+            if(ch45 * nxini.gt.1.d-30) tauo3p(45,i) = 1.d0 / 
      $           (ch45 * nxini)
-            if(ch45 * o3pxini.gt.1.d-30) taun(i,45) = 1.d0 /
+            if(ch45 * o3pxini.gt.1.d-30) taun(45,i) = 1.d0 /
      $           (ch45 * o3pxini)
 
@@ -2047,198 +2046,198 @@
          !Only if ion chemistry requested
          if(chemthermod.eq.3) then
-            if(ch46 * co2plusxini .gt.1.d-30) tauo2(i,46) = 
+            if(ch46 * co2plusxini .gt.1.d-30) tauo2(46,i) = 
      @           1.d0/(ch46*co2plusxini)
-            if(ch46 * o2xini .gt.1.d-30) tauco2plus(i,46) = 
+            if(ch46 * o2xini .gt.1.d-30) tauco2plus(46,i) = 
      @           1.d0/(ch46*o2xini)
 
-            if ( ch47*o3pxini .gt. 1.d-30 ) tauco2plus(i,47) = 
+            if ( ch47*o3pxini .gt. 1.d-30 ) tauco2plus(47,i) = 
      @           1.d0/( ch47*o3pxini )
-            if ( ch47*co2plusxini .gt. 1.d-30 ) tauo3p(i,47) = 
+            if ( ch47*co2plusxini .gt. 1.d-30 ) tauo3p(47,i) = 
      @           1.d0/( ch47*co2plusxini )
             
-            if ( ch48*o3pxini .gt. 1.d-30 ) tauco2plus(i,48) =
+            if ( ch48*o3pxini .gt. 1.d-30 ) tauco2plus(48,i) =
      @           1.d0/(ch48*o3pxini)	   
-            if ( ch48*co2plusxini .gt. 1.d-30 ) tauo3p(i,48) =
+            if ( ch48*co2plusxini .gt. 1.d-30 ) tauo3p(48,i) =
      @           1.d0/(ch48*co2plusxini)	 
 
-            if ( ch49*electxini .gt. 1.d-30 ) tauo2plus(i,49) =
+            if ( ch49*electxini .gt. 1.d-30 ) tauo2plus(49,i) =
      @           1.d0/(ch49*electxini)	 
 
-            if ( ch50*co2xini  .gt. 1.d-30 ) tauoplus(i,50) =
+            if ( ch50*co2xini  .gt. 1.d-30 ) tauoplus(50,i) =
      @           1.d0/(ch50*co2xini)
-            if ( ch50*oplusxini .gt. 1.d-30 ) tauco2(i,50) =
+            if ( ch50*oplusxini .gt. 1.d-30 ) tauco2(50,i) =
      @           1.d0/(ch50*oplusxini)
 
-            if ( jion8(1,i,1).gt.1.d-30 ) tauco2(i,51) = 
+            if ( jion8(1,i,1).gt.1.d-30 ) tauco2(51,i) = 
      $           1.d0 / jion8(1,i,1)
 
-            if ( jion8(1,i,2).gt.1.d-30 ) tauco2(i,52) = 
+            if ( jion8(1,i,2).gt.1.d-30 ) tauco2(52,i) = 
      $           1.d0 / jion8(1,i,2)
 
-            if ( jion8(1,i,3).gt.1.d-30 ) tauco2(i,53) = 
+            if ( jion8(1,i,3).gt.1.d-30 ) tauco2(53,i) = 
      $           1.d0 / jion8(1,i,3)
 
-            if ( jion8(1,i,4).gt.1.d-30 ) tauco2(i,54) = 
+            if ( jion8(1,i,4).gt.1.d-30 ) tauco2(54,i) = 
      $           1.d0 / jion8(1,i,4) 
 		
-            if ( ch55*electxini .gt. 1.d-30 ) tauco2plus(i,55) =
+            if ( ch55*electxini .gt. 1.d-30 ) tauco2plus(55,i) =
      @           1.d0/(ch55*electxini)	 
 
-            if ( ch56*oplusxini .gt. 1.d-30 ) tauco2(i,56) =
+            if ( ch56*oplusxini .gt. 1.d-30 ) tauco2(56,i) =
      @           1.d0/(ch56*oplusxini)
-            if ( ch56*co2xini .gt. 1.d-30 ) tauoplus(i,56) =
+            if ( ch56*co2xini .gt. 1.d-30 ) tauoplus(56,i) =
      @           1.d0/(ch56*co2xini)	
     
-            if ( ch57*coplusxini .gt. 1.d-30 ) tauco2(i,57) =
+            if ( ch57*coplusxini .gt. 1.d-30 ) tauco2(57,i) =
      @           1.d0/(ch57*coplusxini)	 
-            if ( ch57*co2xini .gt. 1.d-30 ) taucoplus(i,57) =
+            if ( ch57*co2xini .gt. 1.d-30 ) taucoplus(57,i) =
      @           1.d0/(ch57*co2xini)
 
-            if ( ch58*coplusxini .gt. 1.d-30 ) tauo3p(i,58) =
+            if ( ch58*coplusxini .gt. 1.d-30 ) tauo3p(58,i) =
      @           1.d0/(ch58*coplusxini)	
-            if ( ch58*o3pxini .gt. 1.d-30 ) taucoplus(i,58) =
+            if ( ch58*o3pxini .gt. 1.d-30 ) taucoplus(58,i) =
      @           1.d0/(ch58*o3pxini)
 
-            if ( ch59*cplusxini .gt. 1.d-30 ) tauco2(i,59) =
+            if ( ch59*cplusxini .gt. 1.d-30 ) tauco2(59,i) =
      @           1.d0/(ch59*cplusxini)	
-            if ( ch59*co2xini .gt. 1.d-30 ) taucplus(i,59) =
+            if ( ch59*co2xini .gt. 1.d-30 ) taucplus(59,i) =
      @           1.d0/(ch59*co2xini)	   	 	 
          
-            if ( jion8(2,i,1).gt.1.d-30 ) tauo2(i,60) = 
+            if ( jion8(2,i,1).gt.1.d-30 ) tauo2(60,i) = 
      $           1.d0 / jion8(2,i,1)
 
-            if ( jion8(3,i,1).gt.1.d-30 ) tauo3p(i,61) = 
+            if ( jion8(3,i,1).gt.1.d-30 ) tauo3p(61,i) = 
      $           1.d0 / jion8(3,i,1)  
 
-            if ( ch62*co2plusxini .gt. 1.d-30 ) tauno(i,62) =
+            if ( ch62*co2plusxini .gt. 1.d-30 ) tauno(62,i) =
      @           1.d0/(ch62*co2plusxini)	
-            if ( ch62*noxini .gt. 1.d-30 ) tauco2plus(i,62) =
+            if ( ch62*noxini .gt. 1.d-30 ) tauco2plus(62,i) =
      @           1.d0/(ch62*noxini)	   	 	 
  
-            if ( ch63*co2plusxini .gt. 1.d-30 ) taun(i,63) =
+            if ( ch63*co2plusxini .gt. 1.d-30 ) taun(63,i) =
      @           1.d0/(ch63*cplusxini)	
-            if ( ch63*nxini .gt. 1.d-30 ) tauco2plus(i,63) =
+            if ( ch63*nxini .gt. 1.d-30 ) tauco2plus(63,i) =
      @           1.d0/(ch63*nxini)	   	 	 
      
-            if ( ch64*o2plusxini .gt. 1.d-30 ) tauno(i,64) =
+            if ( ch64*o2plusxini .gt. 1.d-30 ) tauno(64,i) =
      @           1.d0/(ch64*o2plusxini)	
-            if ( ch64*noxini .gt. 1.d-30 ) tauo2plus(i,64) =
+            if ( ch64*noxini .gt. 1.d-30 ) tauo2plus(64,i) =
      @           1.d0/(ch64*noxini)	   	 	 
    
-            if ( ch65*o2plusxini .gt. 1.d-30 ) taun2(i,65) =
+            if ( ch65*o2plusxini .gt. 1.d-30 ) taun2(65,i) =
      @           1.d0/(ch65*o2plusxini)	
-            if ( ch65*n2xini .gt. 1.d-30 ) tauo2plus(i,65) =
+            if ( ch65*n2xini .gt. 1.d-30 ) tauo2plus(65,i) =
      @           1.d0/(ch65*n2xini)	   	 	 
    
-            if ( ch66*o2plusxini .gt. 1.d-30 ) taun(i,66) =
+            if ( ch66*o2plusxini .gt. 1.d-30 ) taun(66,i) =
      @           1.d0/(ch66*o2plusxini)	
-            if ( ch66*nxini .gt. 1.d-30 ) tauo2plus(i,66) =
+            if ( ch66*nxini .gt. 1.d-30 ) tauo2plus(66,i) =
      @           1.d0/(ch66*nxini)	   	 	 
    
-            if ( ch67*oplusxini .gt. 1.d-30 ) taun2(i,67) =
+            if ( ch67*oplusxini .gt. 1.d-30 ) taun2(67,i) =
      @           1.d0/(ch67*oplusxini)	
-            if ( ch67*n2xini .gt. 1.d-30 ) tauoplus(i,67) =
+            if ( ch67*n2xini .gt. 1.d-30 ) tauoplus(67,i) =
      @           1.d0/(ch67*n2xini)	   	 	 
 
-            if ( ch68*n2plusxini .gt. 1.d-30 ) tauco2(i,68) =
+            if ( ch68*n2plusxini .gt. 1.d-30 ) tauco2(68,i) =
      @           1.d0/(ch68*n2plusxini)
-            if ( ch68*co2xini .gt. 1.d-30 ) taun2plus(i,68) =
+            if ( ch68*co2xini .gt. 1.d-30 ) taun2plus(68,i) =
      @           1.d0/(ch68*co2xini)	   	 	 
     
-            if ( ch69*cplusxini .gt. 1.d-30 ) tauco2(i,69) =
+            if ( ch69*cplusxini .gt. 1.d-30 ) tauco2(69,i) =
      @           1.d0/(ch69*cplusxini)	
-            if ( ch69*co2xini .gt. 1.d-30 ) taucplus(i,69) =
+            if ( ch69*co2xini .gt. 1.d-30 ) taucplus(69,i) =
      @           1.d0/(ch69*co2xini)	   	 	 
             
-            if ( ch70*n2plusxini .gt. 1.d-30 ) tauco(i,70) =
+            if ( ch70*n2plusxini .gt. 1.d-30 ) tauco(70,i) =
      @           1.d0/(ch70*n2plusxini)	
-            if ( ch70*coxini .gt. 1.d-30 ) taun2plus(i,70) =
+            if ( ch70*coxini .gt. 1.d-30 ) taun2plus(70,i) =
      @           1.d0/(ch70*coxini)	   	 	 
             
-            if ( ch71*electxini .gt. 1.d-30 ) taun2plus(i,71) =
+            if ( ch71*electxini .gt. 1.d-30 ) taun2plus(71,i) =
      @           1.d0/(ch71*electxini)	
             
-            if ( ch72*n2plusxini .gt. 1.d-30 ) tauo3p(i,72) =
+            if ( ch72*n2plusxini .gt. 1.d-30 ) tauo3p(72,i) =
      @           1.d0/(ch72*n2plusxini)	
-            if ( ch72*o3pxini .gt. 1.d-30 ) taun2plus(i,72) =
+            if ( ch72*o3pxini .gt. 1.d-30 ) taun2plus(72,i) =
      @           1.d0/(ch72*o3pxini)	   	 	 
      	 	 
-            if ( ch73*coplusxini .gt. 1.d-30 ) tauh(i,73) =
+            if ( ch73*coplusxini .gt. 1.d-30 ) tauh(73,i) =
      @           1.d0/(ch73*coplusxini)	
-            if ( ch73*hxini .gt. 1.d-30 ) taucoplus(i,73) =
+            if ( ch73*hxini .gt. 1.d-30 ) taucoplus(73,i) =
      @           1.d0/(ch73*hxini)	   	 	 
          
-            if ( ch74*oplusxini .gt. 1.d-30 ) tauh(i,74) =
+            if ( ch74*oplusxini .gt. 1.d-30 ) tauh(74,i) =
      @           1.d0/(ch74*oplusxini)	
-            if ( ch74*hxini .gt. 1.d-30 ) tauoplus(i,74) =
+            if ( ch74*hxini .gt. 1.d-30 ) tauoplus(74,i) =
      @           1.d0/(ch74*hxini)	
  
-            if ( ch75*electxini .gt. 1.d-30 ) taunoplus(i,75) =
+            if ( ch75*electxini .gt. 1.d-30 ) taunoplus(75,i) =
      @           1.d0/(ch75*electxini)	   	 	 
             
-            if ( ch76*hplusxini .gt. 1.d-30 ) tauo3p(i,76) =
+            if ( ch76*hplusxini .gt. 1.d-30 ) tauo3p(76,i) =
      @           1.d0/(ch76*hplusxini)	
-            if ( ch76*o3pxini .gt. 1.d-30 ) tauhplus(i,76) =
+            if ( ch76*o3pxini .gt. 1.d-30 ) tauhplus(76,i) =
      @           1.d0/(ch76*o3pxini)	
 	 
-            if( jion8(11,i,1).gt.1.d-30 )  tauco(i,77) = 
+            if( jion8(11,i,1).gt.1.d-30 )  tauco(77,i) = 
      $           1.d0 / jion8(11,i,1)
 
-            if( jion8(11,i,2).gt.1.d-30 )  tauco(i,78) = 
+            if( jion8(11,i,2).gt.1.d-30 )  tauco(78,i) = 
      $           1.d0 / jion8(11,i,2)  
 
-         !if( jion8(11,i,3).gt.1.d-30 ) tauco(i,79) = 
+         !if( jion8(11,i,3).gt.1.d-30 ) tauco(79,i) = 
 !     $        1.d0 / jion8(11,i,3) 
 
-            if( jion8(10,i,1).gt.1.d-30 )  tauno(i,80) = 
+            if( jion8(10,i,1).gt.1.d-30 )  tauno(80,i) = 
      $           1.d0 / jion8(10,i,1) 
          
-            if( jion8(8,i,1).gt.1.d-30 )   taun2(i,81)  = 
+            if( jion8(8,i,1).gt.1.d-30 )   taun2(81,i)  = 
      $           1.d0 / jion8(8,i,1) 
 
-            if( jion8(8,i,2).gt.1.d-30 )   taun2(i,82)  = 
+            if( jion8(8,i,2).gt.1.d-30 )   taun2(82,i)  = 
      $           1.d0 / jion8(8,i,2)
 		 
-            if( jion8(12,i,1).gt.1.d-30 )  tauh(i,83)  = 
+            if( jion8(12,i,1).gt.1.d-30 )  tauh(83,i)  = 
      $           1.d0 / jion8(12,i,1)
 
-            if( jion8(9,i,1).gt.1.d-30 )   taun(i,84)  = 
+            if( jion8(9,i,1).gt.1.d-30 )   taun(84,i)  = 
      $           1.d0 / jion8(9,i,1)
 
-            if ( ch85*nplusxini .gt. 1.d-30 ) tauco2(i,85) =
+            if ( ch85*nplusxini .gt. 1.d-30 ) tauco2(85,i) =
      @           1.d0/(ch85*nplusxini)	
-            if ( ch85*co2xini .gt. 1.d-30 ) taunplus(i,85) =
+            if ( ch85*co2xini .gt. 1.d-30 ) taunplus(85,i) =
      @           1.d0/(ch85*co2xini)
 
-            if ( ch86*co2plusxini .gt. 1.d-30) tauh2(i,86) =
+            if ( ch86*co2plusxini .gt. 1.d-30) tauh2(86,i) =
      $           1.d0/(ch86*co2plusxini)
-            if ( ch86*h2xini .gt. 1.d-30) tauco2plus(i,86) =
+            if ( ch86*h2xini .gt. 1.d-30) tauco2plus(86,i) =
      $           1.d0/(ch86*h2xini)
          
-            if ( ch87*electxini .gt. 1.d-30) tauhco2plus(i,87) =
+            if ( ch87*electxini .gt. 1.d-30) tauhco2plus(87,i) =
      $                  1.d0/(ch87*electxini)
 
             if ( jion8(9,i,1)*ionsec_nplus(zenit,zx(i)).gt.1.d-30) 
-     $           taun(i,88) = 1.d0 / 
+     $           taun(88,i) = 1.d0 / 
      $           (jion8(9,i,1)*ionsec_nplus(zenit,zx(i)))
 
             if ( jion8(8,i,1)*ionsec_n2plus(zenit,zx(i)).gt.1.d-30) 
-     $           taun2(i,89) = 1.d0 / 
+     $           taun2(89,i) = 1.d0 / 
      $           (jion8(8,i,1)*ionsec_n2plus(zenit,zx(i))) 
             
             if ( jion8(3,i,1)*ionsec_oplus(zenit,zx(i)).gt.1.d-30) 
-     $           tauo3p(i,90) = 1.d0 /
+     $           tauo3p(90,i) = 1.d0 /
      $           (jion8(3,i,1)*ionsec_oplus(zenit,zx(i)))
             
             if (jion8(11,i,1)*ionsec_coplus(zenit,zx(i)).gt.1.d-30) 
-     $           tauco(i,91) = 1.d0 /
+     $           tauco(91,i) = 1.d0 /
      $           (jion8(11,i,1)*ionsec_coplus(zenit,zx(i)))
 
             if (jion8(1,i,1)*ionsec_co2plus(zenit,zx(i)).gt.1.d-30) 
-     $           tauco2(i,92) = 1.d0 /
+     $           tauco2(92,i) = 1.d0 /
      $           (jion8(1,i,1)*ionsec_co2plus(zenit,zx(i)))
 
             if ( jion8(2,i,1)*ionsec_o2plus(zenit,zx(i)).gt.1.d-30) 
-     $           tauo2(i,93) = 1.d0 /
+     $           tauo2(93,i) = 1.d0 /
      $           (jion8(2,i,1)*ionsec_o2plus(zenit,zx(i)))
 
@@ -2276,32 +2275,32 @@
 
          do j=1,nreact
-            tminco2(i)  = min(tminco2(i),tauco2(i,j))
-            tmino2(i)   = min(tmino2(i),tauo2(i,j))
-            tmino3p(i)  = min(tmino3p(i),tauo3p(i,j))
-            tminco(i)   = min(tminco(i),tauco(i,j))
-            tminh(i)    = min(tminh(i),tauh(i,j))
-            tminoh(i)   = min(tminoh(i),tauoh(i,j))
-            tminho2(i)  = min(tminho2(i),tauho2(i,j))
-            tminh2(i)   = min(tminh2(i),tauh2(i,j))
-            tminh2o(i)  = min(tminh2o(i),tauh2o(i,j))
-            tmino1d(i)  = min(tmino1d(i),tauo1d(i,j))
-            tminh2o2(i) = min(tminh2o2(i),tauh2o2(i,j))
-            tmino3(i)   = min(tmino3(i),tauo3(i,j))
-            tminn(i)    = min(tminn(i),taun(i,j))
-            tminno(i)   = min(tminno(i),tauno(i,j))
-	    tminn2(i)   = min(tminn2(i),taun2(i,j))
-	    tminn2d(i)  = min(tminn2d(i),taun2d(i,j))
-            tminno2(i)  = min(tminno2(i),tauno2(i,j))
+            tminco2(i)  = min(tminco2(i),tauco2(j,i))
+            tmino2(i)   = min(tmino2(i),tauo2(j,i))
+            tmino3p(i)  = min(tmino3p(i),tauo3p(j,i))
+            tminco(i)   = min(tminco(i),tauco(j,i))
+            tminh(i)    = min(tminh(i),tauh(j,i))
+            tminoh(i)   = min(tminoh(i),tauoh(j,i))
+            tminho2(i)  = min(tminho2(i),tauho2(j,i))
+            tminh2(i)   = min(tminh2(i),tauh2(j,i))
+            tminh2o(i)  = min(tminh2o(i),tauh2o(j,i))
+            tmino1d(i)  = min(tmino1d(i),tauo1d(j,i))
+            tminh2o2(i) = min(tminh2o2(i),tauh2o2(j,i))
+            tmino3(i)   = min(tmino3(i),tauo3(j,i))
+            tminn(i)    = min(tminn(i),taun(j,i))
+            tminno(i)   = min(tminno(i),tauno(j,i))
+	    tminn2(i)   = min(tminn2(i),taun2(j,i))
+	    tminn2d(i)  = min(tminn2d(i),taun2d(j,i))
+            tminno2(i)  = min(tminno2(i),tauno2(j,i))
             !
-            tminco2plus(i) = min(tminco2plus(i),tauco2plus(i,j))
-	    tminoplus(i)   = min(tminoplus(i),tauoplus(i,j))
-            tmino2plus(i)  = min(tmino2plus(i),tauo2plus(i,j))
-            tmincoplus(i)  = min(tmincoplus(i),taucoplus(i,j))
-            tmincplus(i)   = min(tmincplus(i),taucplus(i,j))
-	    tminnplus(i)   = min(tminnplus(i),taunplus(i,j))
-            tminn2plus(i)  = min(tminn2plus(i),taun2plus(i,j))
-            tminnoplus(i)  = min(tminnoplus(i),taunoplus(i,j))
-            tminhplus(i)   = min(tminhplus(i),tauhplus(i,j))
-            tminhco2plus(i)= min(tminhco2plus(i),tauhco2plus(i,j))
+            tminco2plus(i) = min(tminco2plus(i),tauco2plus(j,i))
+	    tminoplus(i)   = min(tminoplus(i),tauoplus(j,i))
+            tmino2plus(i)  = min(tmino2plus(i),tauo2plus(j,i))
+            tmincoplus(i)  = min(tmincoplus(i),taucoplus(j,i))
+            tmincplus(i)   = min(tmincplus(i),taucplus(j,i))
+	    tminnplus(i)   = min(tminnplus(i),taunplus(j,i))
+            tminn2plus(i)  = min(tminn2plus(i),taun2plus(j,i))
+            tminnoplus(i)  = min(tminnoplus(i),taunoplus(j,i))
+            tminhplus(i)   = min(tminhplus(i),tauhplus(j,i))
+            tminhco2plus(i)= min(tminhco2plus(i),tauhco2plus(j,i))
          end do
 
@@ -2441,5 +2440,5 @@
 
       subroutine timemarching( ig,i,chemthermod,n_comp_en_EQ,
-     $     compmin,tmin,timefrac_sec, deltat ) 
+     $     compmin,tmin,timefrac_sec, deltat,fmargin1 ) 
 
   
@@ -2478,5 +2477,5 @@
 ccccccccccccccc CODE STARTS 
 
-      fmargin1=1.
+!      fmargin1=1.
       fmargin2=5.
 
@@ -3661,5 +3660,4 @@
       Lo1dtot(i) = Lo1d(i,9) + Lo1d(i,14) + Lo1d(i,19) + Lo1d(i,20) +
      $     Lo1d(i,31)
-      
 
 c     H2O2
Index: /trunk/LMDZ.MARS/libf/aeronomars/perosat.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/perosat.F	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/perosat.F	(revision 658)
@@ -127,4 +127,6 @@
 c
            zynew(1)=zysat(1)
+        else
+          pdqscloud(ig,igcm_h2o2)=0
         end if
 c
Index: /trunk/LMDZ.MARS/libf/aeronomars/thermosphere.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/thermosphere.F	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/thermosphere.F	(revision 658)
@@ -79,5 +79,5 @@
       if (callmoldiff) THEN
         call zerophys(ngridmx*nlayermx*nqmx,zdqmoldiff)
-        call moldiff(pplay,pplev,pt,pdt,pq,pdq,ptimestep,
+        call moldiff_red(pplay,pplev,pt,pdt,pq,pdq,ptimestep,
      &                   zzlay,zdteuv,zdtconduc,zdqmoldiff)
       endif
